package com.steerinfo.baseinfo.meterbaseuserspot.controller;

import com.steerinfo.baseinfo.meterbasespotinfo.model.MeterBaseSpotInfo;
import com.steerinfo.baseinfo.meterbaseuserspot.mapper.MeterBaseUserSpotMapper;
import com.steerinfo.baseinfo.meterbaseuserspot.model.MeterBaseUserSpot;
import com.steerinfo.baseinfo.meterbaseuserspot.service.IMeterBaseUserSpotService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseUserSpot RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-31 04:18
 * 类描述
 * 修订历史：
 * 日期：2022-03-31
 * 作者：generator
 * 参考：
 * 描述：MeterBaseUserSpot RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseuserspots")
public class MeterBaseUserSpotController extends BaseRESTfulController {

    @Autowired
    IMeterBaseUserSpotService meterBaseUserSpotService;

    @Autowired
    MeterBaseUserSpotMapper meterBaseUserSpotMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserspot:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserSpot> list = meterBaseUserSpotService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserspot:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserSpot> list = meterBaseUserSpotService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult listall(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseUserSpot> list = meterBaseUserSpotService.queryall(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseUserSpot对象创建")
    @ApiImplicitParam(name = "meterBaseUserSpot", value = "详细实体meterBaseUserSpot", required = true, dataType = "MeterBaseUserSpot")
    //@RequiresPermissions("meterbaseuserspot:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBaseUserSpot model){
        MeterBaseUserSpot meterBaseUserSpot = meterBaseUserSpotService.add(model);
        return success(meterBaseUserSpot);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserspot:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseUserSpot meterBaseUserSpot = meterBaseUserSpotService.getById(id);
        return success(meterBaseUserSpot);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseUserSpot信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseUserSpot", value = "详细实体meterBaseUserSpot", required = true, dataType = "MeterBaseUserSpot")
    })
    //@RequiresPermissions("meterbaseuserspot:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseUserSpot model){
        model.setId(id);
        MeterBaseUserSpot meterBaseUserSpot = meterBaseUserSpotService.modify(model);
        return success(meterBaseUserSpot);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserspot:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseUserSpotService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据用户和计量点ID创建对象", notes="根据sso.sys_user表和meter_base_spot_info表的id创建MeterBaseUserSpot对象")
    @PostMapping(value = "/checkAdd")
    public RESTfulResult checkAdd(@RequestBody List<MeterBaseUserSpot> model){
        RESTfulResult rm = failed();
        try{
            rm = meterBaseUserSpotService.checkAdd(model);
            return success(rm);
        }catch(Exception e){
            e.printStackTrace();
            return rm;
        }
    }

    @ApiOperation(value="删除称点信息", notes="通过ID删除")
    @PostMapping(value = "/deleteUserSpot")
    public RESTfulResult deleteUserSpot(@RequestBody List<MeterBaseUserSpot> models){
        RESTfulResult rm = failed();
        try{
            List<String> list = new ArrayList<String>();
            for (MeterBaseUserSpot model:models){
                String id = model.getId();
                list.add(id);
            }
            if(ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseUserSpotService.delete(ids);
            }
            return success();
        }catch(Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请重试");
        }
    }
}
